/*  part 4b */
/******************************************************************************
PURPOSE:	This is part 4b of assignment 3.  The purpose is to write a 
                program in which the process with rank 0 scatters a message to 
		all processes via MPI_COMM_WORLD and then gathers back the 
		message. How do the execution times of this program and the 
		previous one compare?
AUTHOR:		Marjorie Quant
CLASS:		CPS 615 -- Computational Science for Simulation
*******************************************************************************/

#include <stdio.h>
#include <mpi.h>

void main (int argc, char *argv[])
{
  int rank, p;
  int length;
  int ping[100000];
  int pong[100000];
  double start, finish, total_time;
  MPI_Status status;
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &p);


  
  
  if (rank == 0){
  printf("Total Time\n");}

  for (length = 1; length <=100000; length+=1000)
  { 
   if (rank == 0)
     {
      start = MPI_Wtime();
     }

   MPI_Scatter(ping, length/p, MPI_INT, pong, length/p, MPI_INT, 0, MPI_COMM_WORLD);
   MPI_Gather(pong, length/p, MPI_INT, ping, length/p, MPI_INT, 0, MPI_COMM_WORLD);
   
   if (rank == 0)
     {
       finish = MPI_Wtime();
       total_time = finish - start;
       printf("%d\n", total_time);
     }

  }  /*end of for length */ 

   MPI_Finalize();

} /* end of main */






